#ifndef __DADOSFORM_H_
#define __DADOSFORM_H_

using namespace std;

void DadosForm::init()
{
   matrizes = new MatrizForm(this); 
//   tecido = new Malha;
   tela=false;
}

void DadosForm::monta_matrizes()
{
   matrizes->matrizKTable->setNumCols(tecido->na[0]*tecido->na[1]);
   matrizes->matrizKTable->setNumRows(tecido->na[0]*tecido->na[1]);
   matrizes->matrizATable->setNumCols(tecido->na[0]*tecido->na[1]);
   matrizes->matrizATable->setNumRows(tecido->na[0]*tecido->na[1]);
   matrizes->matrizGTable->setNumRows(tecido->na[0]*tecido->na[1]);
   matrizes->matrizFTable->setNumRows(tecido->na[0]*tecido->na[1]);

   matrizes->exec();
    
}


void DadosForm::carrega_quadro()
{
    // tem q criar o objeto tecido
   int item, pos;
   double valor;
   
    // Inicializacao das tabelas das matrizes K, A, G, F       
   DadosTable->setNumCols(tecido->na[0]*tecido->na[1]);
   
   
   QString aux, path="tmp/quadro";
   item = quadrosComboBox->currentItem();
   
   path=path+QString::number(1+(item*intervalo));
   
   ifstream entrada(path);
   entrada >> valor;
   aux = QString::number(valor);
   QuadroTable->setText(0,0,aux);
   entrada >> valor;
   aux = QString::number(valor);
   QuadroTable->setText(1,0,aux);
   entrada >> valor;
   aux = QString::number(valor);
   QuadroTable->setText(2,0,aux);   
   
   // leitura dos pontos
   for(int i=0;i<tecido->na[0];i++) for(int j=0;j<tecido->na[1];j++)
   {
      pos=i*tecido->na[1]+j;
      entrada >> valor;
//      tecido->r[0]->ve[pos]=valor;
      //printf("\nx=%d\n",valor);
      aux = QString::number(valor);      
      DadosTable->setText(0,pos,aux);   
      entrada >> valor;
//      tecido->r[1]->ve[pos]=valor;
      //printf("\ny=%d\n",valor);
      aux = QString::number(valor);
      DadosTable->setText(1,pos,aux);   
      entrada >> valor;
//      tecido->r[2]->ve[pos]=valor;
      //printf("\nz=%d\n",valor);
      aux = QString::number(valor);
      DadosTable->setText(2,pos,aux);   
   }
   
   
   // leitura das matrizes do sistema
   for(int i=0;i<tecido->na[0];i++) for(int j=0;j<tecido->na[1];j++)
   {
      pos=i*tecido->na[1]+j;
      entrada >> valor;
      //tecido->f[0]->ve[pos]=valor;
      //printf("\nx=%d\n",valor);
      aux = QString::number(valor);      
      matrizes->matrizFTable->setText(pos,0,aux);
      entrada >> valor;
      //tecido->f[1]->ve[pos]=valor;
      //printf("\ny=%d\n",valor);
      aux = QString::number(valor);
      matrizes->matrizFTable->setText(pos,1,aux);
      entrada >> valor;
      //tecido->f[2]->ve[pos]=valor;
      //printf("\nz=%d\n",valor);
      aux = QString::number(valor);
      matrizes->matrizFTable->setText(pos,2,aux);
      
      
      entrada >> valor;
      //tecido->g[0]->ve[pos]=valor;
      //printf("\nx=%d\n",valor);
      aux = QString::number(valor);      
      matrizes->matrizGTable->setText(pos,0,aux);
      entrada >> valor;
      //tecido->g[1]->ve[pos]=valor;
      //printf("\ny=%d\n",valor);
      aux = QString::number(valor);
      matrizes->matrizGTable->setText(pos,1,aux);
      entrada >> valor;
      //tecido->g[2]->ve[pos]=valor;
      //printf("\nz=%d\n",valor);
      aux = QString::number(valor);
      matrizes->matrizGTable->setText(pos,2,aux);

   }
   
   
   
   for(int linha=0;linha < (tecido->na[0]*tecido->na[1]);linha++) 
      for(int coluna=0;coluna < (tecido->na[0]*tecido->na[1]);coluna++)
       {
          entrada >> valor;
          aux = QString::number(valor);
          matrizes->matrizKTable->setText(linha,coluna,aux);
          entrada >> valor;
          aux = QString::number(valor);
          matrizes->matrizATable->setText(linha,coluna,aux);
   
       }

   
//   matrizes->matrizATable->setText(0,120,"A (0,1)");
//   matrizes->matrizKTable->setText(120,0,"K (1,0)");
   
   entrada.close();
   
 
   for(int coluna=0;coluna<3;coluna++) 
   {
       matrizes->matrizGTable->adjustColumn(coluna);
       matrizes->matrizFTable->adjustColumn(coluna);
   }
   
   for(int coluna=0;coluna<tecido->na[0]*tecido->na[1];coluna++) 
   {
      matrizes->matrizKTable->adjustColumn(coluna);
      matrizes->matrizATable->adjustColumn(coluna);
      DadosTable->adjustColumn(coluna);
   }
}

void DadosForm::renderiza_superficie()
{
  
    
/*   int item, quadro; */
  
/*   item = quadrosComboBox->currentItem(); */
  
/*   quadro = (1+(item*intervalo)); */
  
/*    Tela = new Render(this,tecido); */
/*    Tela->setGeometry(16,110,980,680); */

/*   //Tela->setFixedSize(500,500); */
/*   //Tela->setBaseSize(500,500); */
  
  
/*   Tela->estatico = true; */
  
/*   //Tela->dados */
  
/* //  Tela->chave = quadro; */
  
/*   Tela->show(); */
/*   tela=true; */
  
  
}

void DadosForm::trocaContexto()
{
    
    
    if(tela) 
    {
       Tela->hide();
       DadosTable->show();
       tela=false;
    }
    else
    {
       DadosTable->hide();
       Tela->show();
       tela=true;

    }
    

}


#endif // _DADOSFORM_H_




